Index: moodle/blocks/navigation/navigation.js
--- moodle/blocks/navigation/navigation.js No Base Revision
+++ moodle/blocks/navigation/navigation.js Locally New
@@ -0,0 +1,358 @@
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains classes used to manage the navigation structures in Moodle
+ * and was introduced as part of the changes occuring in Moodle 2.0
+ *
+ * @since 2.0
+ * @package javascript
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * This namespace will contain all of the contents of the navigation blocks
+ * global navigation and settings.
+ * @namespace
+ */
+M.block_navigation = M.block_navigation || {
+    /** The number of expandable branches in existence */
+    expandablebranchcount:0,
+    /** An array of initialised trees */
+    treecollection:[],
+    /**
+     * Will contain all of the classes for the navigation blocks
+     * @namespace
+     */
+    classes:{},
+    /**
+     * This function gets called when the module is first loaded as required by
+     * the YUI.add statement at the bottom of the page.
+     * 
+     * NOTE: This will only be executed ONCE
+     * @function
+     */
+    init:function(Y) {
+        if (M.core_dock.genericblock) {
+            // Give the tree class the dock block properties
+            Y.augment(M.block_navigation.classes.tree, M.core_dock.genericblock);
+        }
+    },
+    /**
+     * Add new instance of navigation tree to tree collection
+     */
+    init_add_tree:function(Y, id, properties) {
+    	M.block_navigation.treecollection[id] = new M.block_navigation.classes.tree(Y, id, properties);
+    }
+};
+
+/**
+ * @class tree
+ * @constructor
+ * @base M.core_dock.genericblock
+ * @param {YUI} Y A yui instance to use with the navigation
+ * @param {string} id The name of the tree
+ * @param {object} properties Object containing tree properties
+ */
+M.block_navigation.classes.tree = function(Y, id, properties) {
+    this.Y = Y;
+    this.id = id;
+    this.key = id;
+    this.errorlog = [];
+    this.ajaxbranches = 0;
+    this.expansions = [];
+    this.instance = id;
+    this.cachedcontentnode = null;
+    this.cachedfooter = null;
+    this.position = 'block';
+    this.skipsetposition = false;
+    this.candock = false;
+    
+    if (properties.expansions) {
+        this.expansions = properties.expansions;
+    }
+    if (properties.instance) {
+        this.instance = properties.instance;
+    }
+    if (properties.candock) {
+        this.candock = true;
+    }
+
+    var node = this.Y.one('#inst'+this.id);
+    
+    // Can't find the block instance within the page
+    if (node === null) {
+        return;
+    }
+
+    var reloadicon = node.one('.footer .reloadnavigation');
+    if (reloadicon) {
+        reloadicon.remove();
+    }
+    
+    // Attach event to toggle expansion
+    node.all('.tree_item.branch').on('click', this.toggleexpansion , this);
+
+    // Attache events to expand by AJAX
+    for (var i in this.expansions) {
+        this.Y.one('#'+this.expansions[i].id).on('ajaxload|click', this.init_load_ajax, this, this.expansions[i]);
+        M.block_navigation.expandablebranchcount++;
+    }
+
+    if (node.hasClass('block_js_expansion')) {
+        node.on('mouseover', function(e){this.toggleClass('mouseover');}, node);
+        node.on('mouseout', function(e){this.toggleClass('mouseover');}, node);
+    }
+
+    // Call the generic blocks init method to add all the generic stuff
+    if (this.candock) {
+        this.init(Y, node);
+    }
+
+    if (reloadicon) {
+        node.one('.header .block_action').insert(reloadicon, 0);
+    }
+}
+
+/**
+ * Loads a branch via AJAX
+ * @param {event} e The event object
+ * @param {object} branch A branch to load via ajax
+ */
+M.block_navigation.classes.tree.prototype.init_load_ajax = function(e, branch) {
+    e.stopPropagation();
+    if (e.target.get('nodeName').toUpperCase() != 'P') {
+        return true;
+    }
+    var cfginstance = '';
+    if (this.instance != null) {
+        cfginstance = '&instance='+this.instance
+    }
+    this.Y.io(M.cfg.wwwroot+'/lib/ajax/getnavbranch.php', {
+        method:'POST',
+        data:'elementid='+branch.id+'&id='+branch.branchid+'&type='+branch.type+'&sesskey='+M.cfg.sesskey+cfginstance,
+        on: {
+            complete:this.load_ajax,
+            success:function() {this.Y.detach('click', this.init_load_ajax, e.target);}
+        },
+        context:this,
+        arguments:{
+            target:e.target
+        }
+    });
+    return true;
+}
+
+/**
+ * Takes an branch provided through ajax and loads it into the tree
+ * @param {int} tid The transaction id
+ * @param {object} outcome
+ * @param {mixed} args
+ * @return bool
+ */
+M.block_navigation.classes.tree.prototype.load_ajax = function(tid, outcome, args) {
+    try {
+        var object = this.Y.JSON.parse(outcome.responseText);
+        if (this.add_branch(object, args.target.ancestor('LI') ,1)) {
+            if (this.candock) {
+                M.core_dock.resize();
+            }
+            return true;
+        }
+    } catch (e) {
+        // If we got here then there was an error parsing the result
+    }
+    // The branch is empty so class it accordingly
+    args.target.replaceClass('branch', 'emptybranch');
+    return true;
+}
+
+/**
+ * Adds a branch into the tree provided with some XML
+ * @param {xmldoc} branchxml
+ * @param {Y.Node} target
+ * @param {int} depth
+ * @return bool
+ */
+M.block_navigation.classes.tree.prototype.add_branch = function(branchobj, target, depth) {
+
+    // Make the new branch into an object
+    var branch = new M.block_navigation.classes.branch(this, branchobj);
+
+    var childrenul = false;
+    if (depth === 1) {
+        if (!branch.children) {
+            return false;
+        }
+        childrenul = this.Y.Node.create('<ul></ul>');
+        target.appendChild(childrenul);
+    } else {
+        childrenul = branch.inject_into_dom(target);
+    }
+    if (childrenul) {
+        for (i in branch.children) {
+            // Add each branch to the tree
+            this.add_branch(branch.children[i], childrenul, depth+1);
+        }
+    }
+    return true;
+}
+/**
+ * Toggle a branch as expanded or collapsed
+ * @param {Event} e
+ */
+M.block_navigation.classes.tree.prototype.toggleexpansion = function(e) {
+    // First check if they managed to click on the li iteslf, then find the closest
+    // LI ancestor and use that
+
+    if (e.target.get('nodeName').toUpperCase() == 'A') {
+        // A link has been clicked don't fire any more events just do the default.
+        e.stopPropagation();
+        return;
+    }
+
+    if (e.target.get('nodeName').toUpperCase() == 'LI') {
+        e.target.toggleClass('collapsed');
+    } else if (e.target.ancestor('LI')) {
+        e.target.ancestor('LI').toggleClass('collapsed');
+    }
+    if (this.candock) {
+        M.core_dock.resize();
+    }
+}
+
+/**
+ * This class represents a branch for a tree
+ * @class branch
+ * @constructor
+ * @param {M.block_navigation.classes.tree} tree
+ * @param {object|null} obj
+ */
+M.block_navigation.classes.branch = function(tree, obj) {
+    this.tree = tree;
+    this.name = null;
+    this.title = null;
+    this.classname = null;
+    this.id = null;
+    this.key = null;
+    this.type = null;
+    this.link = null;
+    this.icon = null;
+    this.expandable = null;
+    this.expansionceiling = null;
+    this.hidden = false;
+    this.haschildren = false;
+    this.children = false;
+    if (obj !== null) {
+        // Construct from the provided xml
+        this.construct_from_json(obj);
+    }
+}
+M.block_navigation.classes.branch.prototype.construct_from_json = function(obj) {
+    for (var i in obj) {
+        this[i] = obj[i];
+    }
+    if (this.children) {
+        this.haschildren = true;
+    } else {
+        this.children = [];
+    }
+    if (this.id && this.id.match(/^expandable_branch_\d+$/)) {
+        // Assign a new unique id for this new expandable branch
+        M.block_navigation.expandablebranchcount++;
+        this.id = 'expandable_branch_'+M.block_navigation.expandablebranchcount;
+    }
+}
+/**
+ * Injects a branch into the tree at the given location
+ * @param {element} element
+ */
+M.block_navigation.classes.branch.prototype.inject_into_dom = function(element) {
+
+    var branchli = this.tree.Y.Node.create('<li></li>');
+    var branchp = this.tree.Y.Node.create('<p class="tree_item"></p>');
+
+    if ((this.expandable !== null || this.haschildren) && this.expansionceiling===null) {
+        branchli.addClass('collapsed');
+        branchp.addClass('branch');
+        branchp.on('click', this.tree.toggleexpansion, this.tree);
+        if (this.expandable) {
+            branchp.on('ajaxload|click', this.tree.init_load_ajax, this.tree, {branchid:this.key,id:this.id,type:this.type});
+        }
+    }
+
+    if (this.myclass !== null) {
+        branchp.addClass(this.myclass);
+    }
+    if (this.id !== null) {
+        branchp.setAttribute('id', this.id);
+    }
+
+    // Prepare the icon, should be an object representing a pix_icon
+    var branchicon = false;
+    if (this.icon != null) {
+        branchicon = this.tree.Y.Node.create('<img src="'+M.util.image_url(this.icon.pix, this.icon.component)+'" alt="" />');
+        if (this.icon.alt) {
+            branchicon.setAttribute('alt', this.icon.alt);
+        }
+        if (this.icon.title) {
+            branchicon.setAttribute('alt', this.icon.title);
+        }
+        if (this.icon.classes) {
+            for (var i in this.icon.classes) {
+                branchicon.addClass(this.icon.classes[i]);
+            }
+        }
+        this.name = '&nbsp;'+this.name;
+    }
+    
+    if (this.link === null) {
+        if (branchicon) {
+            branchp.appendChild(branchicon);
+        }
+        branchp.append(this.name.replace(/\n/g, '<br />'));
+    } else {
+        var branchlink = this.tree.Y.Node.create('<a title="'+this.title+'" href="'+this.link+'"></a>');
+        if (branchicon) {
+            branchlink.appendChild(branchicon);
+        }
+        branchlink.append(this.name.replace(/\n/g, '<br />'));
+        if (this.hidden) {
+            branchlink.addClass('dimmed');
+        }
+        branchp.appendChild(branchlink);
+    }
+
+    branchli.appendChild(branchp);
+    if (this.haschildren) {
+        var childrenul = this.tree.Y.Node.create('<ul></ul>');
+        branchli.appendChild(childrenul);
+        element.appendChild(branchli);
+        return childrenul
+    } else {
+        element.appendChild(branchli);
+        return false;
+    }
+}
+
+/**
+ * Causes the navigation block module to initalise the first time the module
+ * is used!
+ *
+ * NOTE: Never convert the second argument to a function reference...
+ * doing so causes scoping issues
+ */
+YUI.add('block_navigation', function(Y){M.block_navigation.init(Y);}, '0.0.0.1', M.yui.loader.modules.block_navigation.requires);
Index: moodle/blocks/navigation/renderer.php
--- moodle/blocks/navigation/renderer.php No Base Revision
+++ moodle/blocks/navigation/renderer.php Locally New
@@ -0,0 +1,101 @@
+<?php
+
+class block_navigation_renderer extends plugin_renderer_base {
+
+    public function navigation_tree(global_navigation $navigation) {
+        $content = $this->navigation_node(array($navigation), array('class'=>'block_tree list'));
+        if (isset($navigation->id) && !is_numeric($navigation->id) && !empty($content)) {
+            $content = $this->output->box($content, 'block_tree_box', $navigation->id);
+        }
+        return $content;
+    }
+
+    protected function navigation_node($items, $attrs=array()) {
+
+        // exit if empty, we don't want an empty ul element
+        if (count($items)==0) {
+            return '';
+        }
+
+        // array of nested li elements
+        $lis = array();
+        foreach ($items as $item) {
+            if (!$item->display) {
+                continue;
+            }
+            $content = $item->get_content();
+            $title = $item->get_title();
+            if ($item->icon instanceof renderable) {
+                $icon = $this->output->render($item->icon);
+                $content = $icon.'&nbsp;'.$content; // use CSS for spacing of icons
+            }
+            if ($item->helpbutton !== null) {
+                $content = trim($item->helpbutton).html_writer::tag('span', $content, array('class'=>'clearhelpbutton'));
+            }
+
+            if ($content === '') {
+                continue;
+            }
+
+            if ($item->action instanceof action_link) {
+                //TODO: to be replaced with something else
+                $link = $item->action;
+                if ($item->hidden) {
+                    $link->add_class('dimmed');
+                }
+                $content = $this->output->render($link);
+            } else if ($item->action instanceof moodle_url) {
+                $attributes = array();
+                if ($title !== '') {
+                    $attributes['title'] = $title;
+                }
+                if ($item->hidden) {
+                    $attributes['class'] = 'dimmed_text';
+                }
+                $content = html_writer::link($item->action, $content, $attributes);
+
+            } else if (is_string($item->action) || empty($item->action)) {
+                $attributes = array();
+                if ($title !== '') {
+                    $attributes['title'] = $title;
+                }
+                if ($item->hidden) {
+                    $attributes['class'] = 'dimmed_text';
+                }
+                $content = html_writer::tag('span', $content, $attributes);
+            }
+
+            // this applies to the li item which contains all child lists too
+            $liclasses = array($item->get_css_type());
+            if (!$item->forceopen || (!$item->forceopen && $item->collapse) || ($item->children->count()==0  && $item->nodetype==navigation_node::NODETYPE_BRANCH)) {
+                $liclasses[] = 'collapsed';
+            }
+            if ($item->isactive === true) {
+                $liclasses[] = 'current_branch';
+            }
+            $liattr = array('class'=>join(' ',$liclasses));
+            // class attribute on the div item which only contains the item content
+            $divclasses = array('tree_item');
+            if ($item->has_children()) {
+                $divclasses[] = 'branch';
+            } else {
+                $divclasses[] = 'leaf';
+            }
+            if (!empty($item->classes) && count($item->classes)>0) {
+                $divclasses[] = join(' ', $item->classes);
+            }
+            $divattr = array('class'=>join(' ', $divclasses));
+            if (!empty($item->id)) {
+                $divattr['id'] = $item->id;
+            }
+            $content = html_writer::tag('p', $content, $divattr) . $this->navigation_node($item->children);
+            if (!empty($item->preceedwithhr) && $item->preceedwithhr===true) {
+                $content = html_writer::empty_tag('hr') . $content;
+            }
+            $content = html_writer::tag('li', $content, $liattr);
+            $lis[] = $content;
+        }
+        return html_writer::tag('ul', implode("\n", $lis), $attrs);
+    }
+
+}
Index: moodle/blocks/settings/block_settings.php
--- moodle/blocks/settings/block_settings.php No Base Revision
+++ moodle/blocks/settings/block_settings.php Locally New
@@ -0,0 +1,155 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains classes used to manage the navigation structures in Moodle
+ * and was introduced as part of the changes occuring in Moodle 2.0
+ *
+ * @since 2.0
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * The settings navigation tree block class
+ *
+ * Used to produce the settings navigation block new to Moodle 2.0
+ *
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class block_settings extends block_base {
+
+    /** @var string */
+    public static $navcount;
+    public $blockname = null;
+    /** @var bool */
+    protected $contentgenerated = false;
+    /** @var bool|null */
+    protected $docked = null;
+
+    /**
+     * Set the initial properties for the block
+     */
+    function init() {
+        $this->blockname = get_class($this);
+        $this->title = get_string('pluginname', $this->blockname);
+        $this->version = 2009082800;
+    }
+
+    /**
+     * All multiple instances of this block
+     * @return bool Returns true
+     */
+    function instance_allow_multiple() {
+        return false;
+    }
+
+    /**
+     * Set the applicable formats for this block to all
+     * @return array
+     */
+    function applicable_formats() {
+        return array('all' => true);
+    }
+
+    /**
+     * Allow the user to configure a block instance
+     * @return bool Returns true
+     */
+    function instance_allow_config() {
+        return true;
+    }
+
+    function instance_can_be_docked() {
+        return (parent::instance_can_be_docked() && (empty($this->config->enabledock) || $this->config->enabledock=='yes'));
+    }
+
+    function get_required_javascript() {
+        global $CFG;
+        $this->page->requires->js_module(array('name'=>'core_dock', 'fullpath'=>'/blocks/dock.js', 'requires'=>array('base', 'cookie', 'dom', 'io', 'node', 'event-custom', 'event-mouseenter', 'yui2-container')));
+        $module = array('name'=>'block_navigation', 'fullpath'=>'/blocks/navigation/navigation.js', 'requires'=>array('core_dock', 'io', 'node', 'dom', 'event-custom', 'json-parse'));
+        $arguments = array($this->instance->id, array('instance'=>$this->instance->id, 'candock'=>$this->instance_can_be_docked()));
+        $this->page->requires->js_init_call('M.block_navigation.init_add_tree', $arguments, false, $module);
+        user_preference_allow_ajax_update('docked_block_instance_'.$this->instance->id, PARAM_INT);
+    }
+
+    /**
+     * Gets the content for this block by grabbing it from $this->page
+     */
+    function get_content() {
+        global $CFG, $OUTPUT;
+        // First check if we have already generated, don't waste cycles
+        if ($this->contentgenerated === true) {
+            return true;
+        }
+        $this->page->requires->yui2_lib('dom');
+        // JS for navigation moved to the standard theme, the code will probably have to depend on the actual page structure
+        // $this->page->requires->js('/lib/javascript-navigation.js');
+        block_settings::$navcount++;
+
+        // Check if this block has been docked
+        if ($this->docked === null) {
+            $this->docked = get_user_preferences('nav_in_tab_panel_settingsnav'.block_settings::$navcount, 0);
+        }
+
+        // Check if there is a param to change the docked state
+        if ($this->docked && optional_param('undock', null, PARAM_INT)==$this->instance->id) {
+            unset_user_preference('nav_in_tab_panel_settingsnav'.block_settings::$navcount, 0);
+            $url = $this->page->url;
+            $url->remove_params(array('undock'));
+            redirect($url);
+        } else if (!$this->docked && optional_param('dock', null, PARAM_INT)==$this->instance->id) {
+            set_user_preferences(array('nav_in_tab_panel_settingsnav'.block_settings::$navcount=>1));
+            $url = $this->page->url;
+            $url->remove_params(array('dock'));
+            redirect($url);
+        }
+
+        $renderer = $this->page->get_renderer('block_settings');
+        $this->content->text = $renderer->settings_tree($this->page->settingsnav);
+
+        // only do search if you have moodle/site:config
+        if (!empty($this->content->text)) {
+            if (has_capability('moodle/site:config',get_context_instance(CONTEXT_SYSTEM)) ) {
+                $this->content->footer = $renderer->search_form(new moodle_url("$CFG->wwwroot/$CFG->admin/search.php"), optional_param('query', '', PARAM_RAW));
+            } else {
+                $this->content->footer = '';
+            }
+
+            $reloadlink = new moodle_url($this->page->url, array('regenerate'=>'navigation'));
+            $this->content->footer .= $OUTPUT->action_icon($reloadlink, new pix_icon('t/reload', get_string('reload')), null, array('class'=>'customcommand reloadnavigation'));
+
+            if (!empty($this->config->enabledock) && $this->config->enabledock == 'yes') {
+                user_preference_allow_ajax_update('nav_in_tab_panel_settingsnav'.block_settings::$navcount, PARAM_INT);
+            }
+        }
+
+        $this->contentgenerated = true;
+        return true;
+    }
+
+    function html_attributes() {
+        $attributes = parent::html_attributes();
+        if (!empty($this->config->enablehoverexpansion) && $this->config->enablehoverexpansion == 'yes') {
+            $attributes['class'] .= ' block_js_expansion';
+        }
+        return $attributes;
+    }
+}
Index: moodle/blocks/settings/edit_form.php
--- moodle/blocks/settings/edit_form.php No Base Revision
+++ moodle/blocks/settings/edit_form.php Locally New
@@ -0,0 +1,54 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Form for editing settings navigation instances.
+ *
+ * @since 2.0
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * Form for setting navigation instances.
+ *
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class block_settings_edit_form extends block_edit_form {
+    protected function specific_definition($mform) {
+        $mform->addElement('header', 'configheader', get_string('blocksettings', 'block'));
+
+        $yesnooptions = array('yes'=>get_string('yes'), 'no'=>get_string('no'));
+
+        $mform->addElement('select', 'config_enablehoverexpansion', get_string('enablehoverexpansion', $this->block->blockname), $yesnooptions);
+        if (empty($this->block->config->enablehoverexpansion) || $this->block->config->enablehoverexpansion=='no') {
+            $mform->getElement('config_enablehoverexpansion')->setSelected('no');
+        } else {
+            $mform->getElement('config_enablehoverexpansion')->setSelected('yes');
+        }
+
+        $mform->addElement('select', 'config_enabledock', get_string('enabledock', $this->block->blockname), $yesnooptions);
+        if (empty($this->block->config->enabledock) || $this->block->config->enabledock=='yes') {
+            $mform->getElement('config_enabledock')->setSelected('yes');
+        } else {
+            $mform->getElement('config_enabledock')->setSelected('no');
+        }
+    }
+}
Index: moodle/blocks/settings/lang/en/block_settings.php
--- moodle/blocks/settings/lang/en/block_settings.php No Base Revision
+++ moodle/blocks/settings/lang/en/block_settings.php Locally New
@@ -0,0 +1,29 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file contains language strings used in the settings navigation block
+ *
+ * @since 2.0
+ * @package blocks
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+$string['enablehoverexpansion'] = 'Enable mouseover expansion of this block';
+$string['enabledock'] = 'Allow the user to dock this block';
+$string['pluginname'] = 'Settings';
Index: moodle/blocks/settings/renderer.php
--- moodle/blocks/settings/renderer.php No Base Revision
+++ moodle/blocks/settings/renderer.php Locally New
@@ -0,0 +1,79 @@
+<?php
+
+class block_settings_renderer extends plugin_renderer_base {
+
+    public function settings_tree(settings_navigation $navigation) {
+        $count = 0;
+        foreach ($navigation->children as &$child) {
+            $child->preceedwithhr = ($count!==0);
+            $count++;
+        }
+        $content = $this->navigation_node($navigation, array('class'=>'block_tree list'));
+        if (isset($navigation->id) && !is_numeric($navigation->id) && !empty($content)) {
+            $content = $this->output->box($content, 'block_tree_box', $navigation->id);
+        }
+        return $content;
+    }
+
+    protected function navigation_node(navigation_node $node, $attrs=array()) {
+        $items = $node->children;
+
+        // exit if empty, we don't want an empty ul element
+        if ($items->count()==0) {
+            return '';
+        }
+
+        // array of nested li elements
+        $lis = array();
+        foreach ($items as $item) {
+            if (!$item->display) {
+                continue;
+            }
+
+            $content = $this->output->render($item);
+
+            // this applies to the li item which contains all child lists too
+            $liclasses = array($item->get_css_type());
+            if (!$item->forceopen || (!$item->forceopen && $item->collapse) || ($item->children->count()==0  && $item->nodetype==navigation_node::NODETYPE_BRANCH)) {
+                $liclasses[] = 'collapsed';
+            }
+            if ($item->isactive === true) {
+                $liclasses[] = 'current_branch';
+            }
+            $liattr = array('class'=>join(' ',$liclasses));
+            // class attribute on the div item which only contains the item content
+            $divclasses = array('tree_item');
+            if ($item->children->count()>0  || $item->nodetype==navigation_node::NODETYPE_BRANCH) {
+                $divclasses[] = 'branch';
+            } else {
+                $divclasses[] = 'leaf';
+            }
+            if (!empty($item->classes) && count($item->classes)>0) {
+                $divclasses[] = join(' ', $item->classes);
+            }
+            $divattr = array('class'=>join(' ', $divclasses));
+            if (!empty($item->id)) {
+                $divattr['id'] = $item->id;
+            }
+            $content = html_writer::tag('p', $content, $divattr) . $this->navigation_node($item);
+            if (!empty($item->preceedwithhr) && $item->preceedwithhr===true) {
+                $content = html_writer::empty_tag('hr') . $content;
+            }
+            $content = html_writer::tag('li', $content, $liattr);
+            $lis[] = $content;
+        }
+        return html_writer::tag('ul', implode("\n", $lis), $attrs);
+    }
+
+    public function search_form(moodle_url $formtarget, $searchvalue) {
+        $content = html_writer::start_tag('form', array('class'=>'adminsearchform', 'method'=>'get', 'action'=>$formtarget));
+        $content .= html_writer::start_tag('div');
+        $content .= html_writer::tag('label', s(get_string('searchinsettings', 'admin')), array('for'=>'adminsearchquery', 'class'=>'accesshide'));
+        $content .= html_writer::empty_tag('input', array('id'=>'adminsearchquery', 'type'=>'text', 'name'=>'query', 'value'=>s($searchvalue)));
+        $content .= html_writer::empty_tag('input', array('type'=>'submit', 'value'=>s(get_string('search'))));
+        $content .= html_writer::end_tag('div');
+        $content .= html_writer::end_tag('form');
+        return $content;
+    }
+
+}
Index: moodle/config-dist.php
--- moodle/config-dist.php Base (1.132)
+++ moodle/config-dist.php Locally Modified (Based On 1.132)
@@ -217,7 +217,7 @@
 // The blocks in this list will be protected from deletion, and this is primarily
 // used to protect the navigation and settings blocks which can be very hard to
 // get back if accidentally delete.
-//      $CFG->undeletableblocktypes = 'global_navigation_tree,settings_navigation_tree';
+//      $CFG->undeletableblocktypes = 'navigation,settings';
 //
 // You can specify a different class to be created for the $PAGE global, and to
 // compute which blocks appear on each page. However, I cannot think of any good
Index: moodle/course/format/topics/lib.php
--- moodle/course/format/topics/lib.php Base (1.2)
+++ moodle/course/format/topics/lib.php Locally Modified (Based On 1.2)
@@ -33,8 +33,8 @@
  * @param stdClass $modinfo The mod info object for the current course
  * @return bool Returns true
  */
-function callback_topics_load_content(&$navigation, $keys, $course) {
-    $navigation->add_course_section_generic($keys, $course, get_string('topic'), 'topic');
+function callback_topics_load_content(&$navigation, $course, $coursenode) {
+    return $navigation->load_generic_course_sections($course, $coursenode, get_string('topic'), 'topic');
 }
 
 /**
